#snowballs
execute at @e[type=minecraft:snowball,tag=!used] run playsound minecraft:item.firecharge.use master @a ~ ~ ~ 0.4 1.5
execute as @e[type=minecraft:snowball,tag=!used] run tag @s add used
execute at @e[type=minecraft:snowball,tag=used] run particle minecraft:snowflake ~ ~ ~ 0 1 0 0.1 0 normal
execute at @e run kill @e[distance=1.7,limit=1,type=minecraft:snowball,tag=used]
execute at @e[type=snowball,tag=used] run effect give @e[distance=..1.7,limit=1,type=!minecraft:player] minecraft:instant_health 1 1 true
scoreboard players add frostySawKey data 0

#sleeping
execute unless score frostySawKey Data matches 1 if entity @a[scores={Sleeping=1}] run function frosty:animation/sleep/0
execute if score frostySawKey Data matches 1 at @e[type=minecraft:marker,tag=bed] if entity @a[scores={Sleeping=1}] unless entity @a[distance=..1] run function frosty:animation/sleep/0
execute if score frostySawKey Data matches 1 at @e[type=minecraft:marker,tag=bed] if entity @a[scores={Sleeping=1},distance=..1] run function frosty:animation/objective/complete
execute if score frostySawKey Data matches 1 at @e[type=minecraft:marker,tag=bed] if entity @a[scores={Sleeping=1},distance=..1] run schedule function frosty:reset/game 1s
execute if score frostySawKey Data matches 1 at @e[type=minecraft:marker,tag=bed] if entity @a[scores={Sleeping=1},distance=..1] run schedule function frosty:ending/bad 3s
scoreboard players reset @a[scores={Sleeping=1}] Sleeping

#story
execute if score objective Data matches 7..9 unless score frostySawKey Data matches 1 at @e[type=snow_golem,tag=frosty] if entity @a[nbt={SelectedItem:{tag:{makesFrostyUpset:true}}},distance=..4.5] run schedule function frosty:task/saw_key 1t
execute if score objective Data matches 7..9 unless score frostySawKey Data matches 1 at @e[type=snow_golem,tag=frosty] if entity @a[nbt={Inventory:[{Slot:-106b,tag:{makesFrostyUpset:true}}]},distance=..4.5] run schedule function frosty:task/saw_key 1t
execute if score objective Data matches 7..9 unless score frostySawKey Data matches 1 at @e[type=marker,tag=frosty_marker] if score difficulty Settings >= #3 Data if entity @a[nbt={SelectedItem:{tag:{makesFrostyUpset:true}}},distance=..4.5] run schedule function frosty:task/saw_key 1t
execute if score objective Data matches 7..9 unless score frostySawKey Data matches 1 at @e[type=marker,tag=frosty_marker] if score difficulty Settings >= #3 Data if entity @a[nbt={Inventory:[{Slot:-106b,tag:{makesFrostyUpset:true}}]},distance=..4.5] run schedule function frosty:task/saw_key 1t


#detonator
execute if score detonatorEnabled Data <= #1 Data unless entity @a[nbt={SelectedItem:{tag:{detonator:true}}}] if entity @e[type=minecraft:villager,tag=detonator] run tp @e[type=minecraft:villager,tag=detonator] ~ ~ ~
execute if score detonatorEnabled Data <= #1 Data unless entity @a[nbt={SelectedItem:{tag:{detonator:true}}}] if entity @e[type=minecraft:villager,tag=detonator] run kill @e[type=minecraft:villager,tag=detonator]
execute if score detonatorEnabled Data <= #1 Data if entity @a[nbt={SelectedItem:{tag:{detonator:true}}}] unless entity @e[type=minecraft:villager,tag=detonator] run summon minecraft:villager ~ ~ ~ {Tags:["summoned","detonator","invisible"],NoAI:1b,Silent:1b,Invulnerable:1b,Team:nocollision}
execute if score detonatorEnabled Data <= #1 Data at @a[nbt={SelectedItem:{tag:{detonator:true}}}] if entity @e[type=minecraft:villager,tag=detonator] run tp @e[type=minecraft:villager,tag=detonator] ^ ^ ^.5
execute if score detonatorEnabled Data matches 0 as @a[scores={TalkedToVillager=1}] if data entity @s {SelectedItem:{tag:{detonator:true}}} run tellraw @a [{"text":"<"}, {"selector":"@s"}, {"text":"> it would be a bad idea to detonate it right now, I may die."}]
execute if score detonatorEnabled Data matches 1 as @a[scores={TalkedToVillager=1}] if data entity @s {SelectedItem:{tag:{detonator:true}}} run function frosty:animation/objective/complete
execute if score detonatorEnabled Data matches 1 as @a[scores={TalkedToVillager=1}] if data entity @s {SelectedItem:{tag:{detonator:true}}} run function frosty:animation/ending/worst/sound
execute if score detonatorEnabled Data matches 1 as @a[nbt={SelectedItem:{tag:{detonator:true}}},scores={TalkedToVillager=1}] run item replace entity @s weapon.mainhand with lever{display:{Name:'{"text":"Detonator","italic":false}',Lore:['{"text":"right-click to detonate the TNT"}']}}
scoreboard players reset @a TalkedToVillager

#make entities invisible
effect give @e[tag=invisible] invisibility 1 255 true
